Menu

## GridSampler
in package

GridSampler.php : 32

Implementations of this class can, given locations of finder patterns for a QR code in an image, sample the right points in the image to reconstruct the QR code, accounting for perspective distortion. It is abstracted since it is relatively expensive and should be allowed to take advantage of platform-specific optimized implementations, like Sun's Java Advanced Imaging library, but which may not be available in other environments such as J2ME, and vice versa.

The implementation used can be controlled by calling #setGridSampler(GridSampler) with an instance of a class which implements this interface.

##### Tags

author

  Sean Owen

### Table of Contents

sampleGrid() : BitMatrix
  Samples an image for a rectangular matrix of bits of the given dimension. The sampling transformation is determined by the coordinates of 4 points, in the original and transformed image space.
checkAndNudgePoints() : void
  Checks a set of points that have been transformed to sample points on an image against the image's dimensions to see if the point are even within the image.

### Methods

#### sampleGrid()

GridSampler.php : 125

Samples an image for a rectangular matrix of bits of the given dimension. The sampling transformation is determined by the coordinates of 4 points, in the original and transformed image space.

`public sampleGrid(BitMatrix $matrix, int $dimension, PerspectiveTransform $transform) : BitMatrix`

##### Parameters

$matrix : BitMatrix
$dimension : int
$transform : PerspectiveTransform

##### Tags

throws
  QRCodeDetectorException

  if image can't be sampled, for example, if the transformation defined by the given points is invalid or results in sampling outside the image boundaries

##### Return values

BitMatrix —

representing a grid of points sampled from the image within a region defined by the "from" parameters

#### checkAndNudgePoints()

GridSampler.php : 50

Checks a set of points that have been transformed to sample points on an image against the image's dimensions to see if the point are even within the image.

`private checkAndNudgePoints(BitMatrix $matrix, array<string|int, float> $points) : void`

This method will actually "nudge" the endpoints back onto the image if they are found to be barely (less than 1 pixel) off the image. This accounts for imperfect detection of finder patterns in an image where the QR Code runs all the way to the image border.

For efficiency, the method will check points from either end of the line until one is found to be within the image. Because the set of points are assumed to be linear, this is valid.

##### Parameters

$matrix : BitMatrix

  image into which the points should map

$points : array<string|int, float>

  actual points in x1,y1,...,xn,yn form

##### Tags

throws
  QRCodeDetectorException

  if an endpoint is lies outside the image boundaries

##### Return values

void —

## Search results